searchData={"items":[{"type":"module","doc":"Implements a Hush.Provider behaviour to resolve secrets from\nGoogle Secret Manager at runtime.\n\nTo configure this provider, use :hush and :hush_gcp_secret_manager.\n\nThe configuration supplied to :hush_gcp_secret_manager.goth is in the same format as\nyou would configure goth, as per https://github.com/peburrows/goth\n\n    # config.exs\n\n    config :hush,\n      providers: [Hush.Provider.GcpSecretManager]\n\n    config :hush_gcp_secret_manager,\n      project_id: \"my_project_id\",\n      goth: [name: MyApp.Goth, source: ...],\n      goth_timeout: 5_000 # milliseconds","title":"Hush.Provider.GcpSecretManager","ref":"Hush.Provider.GcpSecretManager.html"},{"type":"extras","doc":"# GCP Secret Manager Hush Provider\n\n[![Build Status](https://img.shields.io/github/actions/workflow/status/gordalina/hush_gcp_secret_manager/ci.yml?branch=main&style=flat-square)](https://github.com/gordalina/hush_gcp_secret_manager/actions?query=workflow%3A%22ci%22)\n[![Coverage Status](https://img.shields.io/codecov/c/github/gordalina/hush_gcp_secret_manager?style=flat-square)](https://app.codecov.io/gh/gordalina/hush_gcp_secret_manager)\n[![hex.pm version](https://img.shields.io/hexpm/v/hush_gcp_secret_manager?style=flat-square)](https://hex.pm/packages/hush_gcp_secret_manager)\n[![hex.pm downloads](https://img.shields.io/hexpm/dt/hush_gcp_secret_manager?style=flat-square)]([LICENSE](https://hex.pm/packages/hush_gcp_secret_manager))\n\nThis package provides a [Hush](https://github.com/gordalina/hush) Provider to resolve Google Cloud Platform's [Secret Manager](https://cloud.google.com/secret-manager) secrets.\n\nDocumentation can be found at [https://hexdocs.pm/hush_gcp_secret_manager](https://hexdocs.pm/hush_gcp_secret_manager).","title":"GCP Secret Manager Hush Provider","ref":"readme.html"},{"type":"extras","doc":"The package can be installed by adding `hush_gcp_secret_manager` to your list\nof dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:hush, \"~> 1.0\"},\n    {:hush_gcp_secret_manager, \"~> 1.1\"}\n  ]\nend\n```\n\nThis module relies on `goth` to fetch secrets from the Google Cloud Platform API. As such you need to configure goth which is used in `hush_gcp_secret_manager`, the configuration is the same as if you were to configure a child_spec as per [their documentation](https://github.com/peburrows/goth).\n\nAs the provider needs to start both applications, it needs to registered as a provider in `hush`, so that it gets loaded during startup.\n\n```elixir\n# config/config.exs\n\nalias Hush.Provider.GcpSecretManager\n\n# ensure hush loads GcpSecretManager during startup\nconfig :hush,\n  providers: [GcpSecretManager]\n\nconfig :hush_gcp_secret_manager,\n  project_id: \"my_project_id\",\n  goth: [name: MyApp.Goth, source: ...],\n  goth_timeout: 5_000 # milliseconds\n```","title":"Installation - GCP Secret Manager Hush Provider","ref":"readme.html#installation"},{"type":"extras","doc":"In order to retrieve secrets from GCP, ensure the service account you use has the Secret Manager Secret Accessor role (`roles/secretmanager.secretAccessor`).","title":"GCP Authorization - GCP Secret Manager Hush Provider","ref":"readme.html#gcp-authorization"},{"type":"extras","doc":"The following example reads the password and the pool size for CloudSQL from secret manager into the ecto repo configuration.\n\n```elixir\n# config/prod.exs\n\nalias Hush.Provider.GcpSecretManager\n\nconfig :app, App.Repo,\n  password: {:hush, GcpSecretManager, \"CLOUDSQL_PASSWORD\"},\n  pool_size: {:hush, GcpSecretManager, \"ECTO_POOL_SIZE\", cast: :integer, default: 10}\n```","title":"Usage - GCP Secret Manager Hush Provider","ref":"readme.html#usage"},{"type":"extras","doc":"Hush is released under the Apache License 2.0 - see the [LICENSE](LICENSE) file.","title":"License - GCP Secret Manager Hush Provider","ref":"readme.html#license"},{"type":"extras","doc":"# Changelog","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"- Add support for Elixir 1.17 and OTP 27\n- Drop support for Elixir 1.10","title":"v1.1.0 - Changelog","ref":"changelog.html#v1-1-0"},{"type":"extras","doc":"- Configure `Goth.fetch/2` timeout via configuration key `:goth_timeout`","title":"v1.0.1 - Changelog","ref":"changelog.html#v1-0-1"},{"type":"extras","doc":"- Upgrade Goth to ~> 1.3\n- Switch http client from httpoison to finch (which is already bundled with goth)\n- Upgrade hush to 1.0","title":"v1.0.0 - Changelog","ref":"changelog.html#v1-0-0"},{"type":"extras","doc":"- Bugfix: save application env when loading configuration in Provider mode.","title":"v0.2.2 - Changelog","ref":"changelog.html#v0-2-2"},{"type":"extras","doc":"- Relax version constraint on Hush to ~> 0.2","title":"v0.2.1 - Changelog","ref":"changelog.html#v0-2-1"},{"type":"extras","doc":"- Support Hush v0.2.0","title":"v0.2.0 - Changelog","ref":"changelog.html#v0-2-0"},{"type":"extras","doc":"- Ensure ability to load config from parameter as well as runtime","title":"v0.1.1 - Changelog","ref":"changelog.html#v0-1-1"},{"type":"extras","doc":"- Announced public release","title":"v0.1.0 - Changelog","ref":"changelog.html#v0-1-0"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,48]}}